# *R Reproducible Environment (RRE): R Projects Based on Docker*

# Introduction:
This project template allows the creation of R projects based on Docker images to maximize computational reproducibility. It operates in a very simple way, as depicted in the figure below. To make it work, several steps need to be taken. The first three steps (A, B, C) are required to create an R project. The last step (D) focuses on how to run [R studio](https://www.rstudio.com/) inside a [Docker container](https://hub.docker.com/).

R projects based on Docker images workflow: ![](/README_files/workflow.jpg)

Connecting two systems: 1) [version control](https://about.gitlab.com/topics/version-control/how-implement-version-control/) and 2) [Docker](https://www.docker.com/). The workflow is depicted in the [figure](/README_files/workflow.jpg) below. If you want to use this template for your own project, there are several steps.

## A. Steps taken on [Gitlab](https://gitlab.com/users/sign_in) and [Docker Hub](https://hub.docker.com/)
1. Create an account on Docker Hub.
   1. You need to create an empty repository and create an [access token](https://docs.docker.com/docker-hub/access-tokens/).
2. Create an account on Gitlab.
   1. You need to create an empty repository (do not check add readme).
   2. You also need to create project variables in which information for Gitlab [Continuous Integration (CI)](https://www.youtube.com/watch?v=-CyVpfDQAG0) will be stored.
      1. You can set these variables via the following way: in a created project, go to settings - CI/CD - Variables. Then click `expand` and set the following variables:
         1. `CI_REGISTRY` = docker.io (name of a registry).
         2. `CI_REGISTRY_IMAGE` = index.docker.io/lukasjirinovak/paqvalidation:latest (registry with username, project, and tag).
         3. `CI_REGISTRY_PASSWORD` = xxxxxxxxxxxxxxx (This is the access token [generated by Docker Hub](https://docs.docker.com/docker-hub/access-tokens/) after logging into the account).
         4. `CI_REGISTRY_USER` = lukasjirinovak (username on Docker Hub).
            1. It can happen that for some reason CI/CD variables cause [problems with authentication](./README_files/gitlab_ci.png). If that happens, this problem might be bypassed by [adding these variables](./README_files/gitlab_ci_advar.png) directly into `gitlab-ci.yml`.
               However, this might be potentially dangerous, as you are making your access token publicly available.
               This allows someone to read and write to your Docker Hub repository, based on the access permissions set.


## B. Steps Taken on Local Repository
3. There is a need to download this project template to your local repository.
   1. In the local repository, open the file named `replacement_function.ps1`.
   2. In this file, there is a need to edit the following objects (quoted text represents an example):
      1. `docker_user_new` = "737823971" - Username created on Docker Hub.
      2. `docker_project_new` = "eee" - Name of the repository created on Docker Hub.
      3. `docker_project_and_user_new` = "737823971/eee:latest" - Name of a user and name of a repository created on Docker Hub; the argument `latest` should not be changed.
      4. `full_project_name_new` = "RRE" - Name of the project you want to create from this template.
      5. `image_version_new` = "rocker/tidyverse:4.2.1" - Name of an image used to build the Docker container; 
         1. the number `4.2.1` indicates the version of an image, if you want to use the most recent version of the `tidyverse` image, it can be found [here](https://hub.docker.com/r/rocker/tidyverse/tags).
      6. `MAINTAINER_new` = "Lukas Novak <lukasjirinovak@gmail.com>" - Name of the person who created the new project.
      7. `git_user_name_new` = "lukas.novak" - Username created on a remote repository (e.g., Gitlab, Github).
      8. `git_user_email_new` = "lukasjirinovak@gmail.com" - Email associated with the remote repository.
      9. `git_url_new` = "https://gitlab.com/lukas.novak/RRE.git" - URL of the newly created remote repository, as done in step A (2.1).
      10. `R_project_name_new` = "project-name" - Name of the R project.
   3. After completing the previous steps, there is a need to open `replacement_function.ps1` in PowerShell.

## C. Uploading Files to Gitlab
1. Open a terminal in the folder where your project files are stored.
2. In the terminal, type the following commands:
   1. `git config --global user.name "lukas.novak"` - Username created on a remote repository (e.g., Gitlab, Github).
   2. `git config --global user.email "lukasjirinovak@gmail.com"` - Email associated with the remote repository.
   3. `git init` - Initialize a git repository in the current folder.
   4. `git remote add origin "https://gitlab.com/lukas.novak/RRE.git"` - Add the remote repository created in step A (2.1).
   5. `git add .` - Add all files.
   6. `git commit -m "initial commit"` - Commit with an initial message.
   7. `git push --set-upstream origin master` - Set a new branch upstream.
   8. `git push` - Push files to the remote repository.

## D. Starting RStudio Server

### 1. Open the folder, find the file named `project_start.ps1`, right-click it and select `Run with PowerShell`. 
![](/README_files/powershell_run.jpg)

### 2. After Windows PowerShell opens, it installs the necessary project components. This process may take some time. The [Docker Desktop](/README_files/docker_img.jpg) should appear - you can minimize this program. 
![](/README_files/open_powershell_w.jpg)

### 3. Finally, you should see a new tab in your web browser where RStudio can be accessed. 
![](/README_files/r_studio_server.jpg)

### 4. Click on the R Markdown File `.Rmd` located in the project directory. 
![](/README_files/r_studio_server_rmd.jpg)

### 5. Click on the `Knit` button. 
![](/README_files/rmarkdown_knit.jpg)

### 6. After [RStudio](https://www.r-project.org/) completes the knitting operation, you should be able to download the report.

## Notes
The markdown file for your project, which might be attached to this project in a remote repository, is available [here](/README_files/README.md).
